            global DHS_offset DHS_dx DHS_dy

% IMC parameters
            RoCMC2 = 185.1;
            Ltot = 143.424 * 2;
            L13 = 86.25e-3;
            L12 = (Ltot - L13)/2;
            theta2 = atan( L13/2/L12 );
            theta1 = (pi/2 - theta2)/2;
            thick13 = 0.03;
            thick2 = 0.09;
            T_MC1 = 2314e-6;
            T_MC3 = 2410e-6;
            Lar_MC13 = 1900e-6;
            Lhr_MC1 = 4.5e-6;
            Lhr_MC3 = 9e-6;
            L_MC2 = 13e-6;
            T_MC2 = 2.2e-6;
            
            Aperture13 = 80e-3;  % 40mm aperture -> 40*sqrt(2) = 56mm
            Aperture2 = 140e-3;  % 10 x beam size
            
            % make this not to use the mirror maps
            mapWgt = 1;
            
            % MC2 center and tilt
            x0 = 0;
            y0 = 0;
            tiltY = 0;
            tiltX = 0;

            % power absorption on each mirror
            PcoatMC2 = 0;
            PcoatMC1 = 0;
            PcoatMC3 = 0;
            
            % = 1 to include backscatter. Don't change, necessary codes are
            % missing
            MC2type = 0;
            
            % dihedron mirror maps, 0 for old, 1 for new
            mirSet = 1;
            
            % MC2 map
            MC2map = 'MC_end_mirror_map_surface_2.col';
            
            % place shield infront of the dihedron mirror
            useShield = 1;
            % separation of the holes on the shiels
            dHoles = 90e-3;
            % horizontal offset of the hole
            offset = 0;
            % the location of the center of the mirror
            dx = (dHoles - L13)/2;
            dy = 0;
            
            % resolution of MC2 map. 0 means default
            res2 = 0;
            
            % parameters defined above can be changed as the runtime parameters,
            % imc = AdVirgoIMCIFO( 'parameter name', parameter value ),
            % examples are
            % imc = AdVirgoIMCIFO('PcoatMC2', 0.2) or imc = AdVirgoIMCIFO('MC2map', '');
            eval( UtilTK.setVars( who, true, varargin{:} ) );
            
            DHS_offset = offset;
            DHS_dx = dx;
            DHS_dy = dy;
            
            if mirSet == 0
                MC1map = 'suba__S14018_2_50mmCA.col';
                MC3map = 'subb_50mm_S14018_1_CA.col';
            elseif mirSet == 1
                MC1map = 'c14065_10_subA_50mm.dat';
                MC3map = 'c14065_20_subB_50mm.dat';
            else
                MC1map = '';
                MC3map = '';
                if mirSet < 0
                    MC2map = '';
                end
            end
            
            Ltot = 2*L12 + L13;
            fprintf(1,'Ltot = %g, C/2L = %12.8f\n', Ltot, ConstantTK.c/Ltot);
            
            % IMC optics
            if MC2type == 0
                MC2Mirror = 'Mirror4x4Obj';
            else
                % this supports the back scattering on MC2
                % special locking code is needed
                MC2Mirror = 'VirgoMC2';
            end