% 
% Written by Richard Day of EGO
% version dated August 2013
% this is the latest - so far - which has the Gabriele's contribution
% 34 digits is not quite necessary, but there is almost no speed gain by reducing to 28
%

function [EG, ratio]  = R_getguessFin(P,E,Et)

mysize = size(P);
CavN = sqrt(mysize(1));
AccN = mysize(2);

for j=1:CavN*CavN
    for k=2:AccN
        P{j,k}=P{j,k}-P{j,1};
    end
end

sgn=2*eye(CavN,CavN)-ones(CavN,CavN);

B1 = (zeros(CavN*AccN,CavN*AccN));
B2 = (zeros(CavN*AccN,CavN*AccN));
B3 = (zeros(CavN*AccN,CavN*AccN));
B4 = (zeros(CavN*AccN,CavN*AccN));

for j=1:CavN
    for k=1:CavN
        if ( (  ~isempty(P{(j-1)*CavN+j,1})  ) && (  ~isempty(P{(j-1)*CavN+k,1})  ) )
            B1(((j-1)*AccN+1):((j-1)*AccN+AccN),((k-1)*AccN+1):((k-1)*AccN+AccN)) = sgn(j,k) * sum(sum(conj(P{(j-1)*CavN+j,1}) .* P{(j-1)*CavN+k,1}));
            for p=2:AccN
                B2(((j-1)*AccN+p),((k-1)*AccN+1):((k-1)*AccN+AccN)) = sgn(j,k) * sum(sum(conj(P{(j-1)*CavN+j,p}) .* P{(j-1)*CavN+k,1}));
            end
            for p=2:AccN
                B3(((j-1)*AccN+1):((j-1)*AccN+AccN),((k-1)*AccN+p)) = sgn(j,k) * sum(sum(conj(P{(j-1)*CavN+j,1}) .* P{(j-1)*CavN+k,p}));
            end
            for p=2:AccN
                for q=2:AccN
                    B4(((j-1)*AccN+p),((k-1)*AccN+q)) = sgn(j,k) * sum(sum(conj(P{(j-1)*CavN+j,p}) .* P{(j-1)*CavN+k,q}));
                end
            end
        end
    end
end

R1 = zeros(AccN*CavN,1);
R2 = zeros(AccN*CavN,1);
for m=1:CavN
    if ( (~isempty(P{m+(m-1)*CavN,1})) && (~isempty(Et{m})) )
        R1((m-1)*AccN+1:(m-1)*AccN+AccN) = sum(sum(conj(P{m+(m-1)*CavN,1}) .* Et{m}));
        for l=2:AccN
            R2(l+(m-1)*AccN) = sum(sum(conj(P{m+(m-1)*CavN,l}) .* Et{m}));
        end
    end
end

% flag=1 matlab vpa(34)
% flag=2 advanpix mp(34)
% flag=3 standard double
ratio = 1/cond(B1+B2+B3+B4);
if (ratio<1e-15)
    flag = 1;
else
    flag = 3;
end

coefs  = R_thecalc(B1,B2+B3,B4,R1,R2,flag);

EG=cell(CavN,1);
EG(:)={zeros(size(E{1}))};
for q=1:CavN
    for j=1:AccN
        EG{q} = EG{q} + coefs(j+(q-1)*AccN)*E{q,j};
    end
end
return

function coefs  = R_thecalc(B1,B23,B4,R1,R2,flag)

switch flag
    case 1
        dig = digits(34); % save current digits
        coefs=(vpa(B1)+vpa(B23)+vpa(B4))\(vpa(R1)+vpa(R2));
        digits(dig);  % restore the previous
    case 2
        mp.Digits(34);
        mp.GuardDigits(0);
        coefs=(mp(B1)+mp(B23)+mp(B4))\(mp(R1)+mp(R2));
    case 3
        coefs=(B1+B23+B4)\(R1+R2);
end

coefs=double(coefs);
return
