%
% simple one mirror reflection and transmission
% input to the object is used in defineIFO to change local variables
% The following does not trick
%       eval( UtilTK.setVars( who, true, varargin{:} ) );
%
classdef BSmap < FFTIFO

    methods       
        function obj = BSmap( varargin )
            obj@FFTIFO( varargin{:} );
        end
        
        function defineIFO( obj, varargin )
            % default values
            incAngle = 25/180*pi;
            lamX = 0.03;
            
            % inject to HRx or to ARy
            portIndex = 1;
            % choose HRx or ARy
            eval( UtilTK.setVars( who, true, varargin{:} ) );
            if portIndex ~= 1
                portIndex = 4;
            end
            
            % setup optics
            obj.optics.addLaser( 'src' );
            %   id = addBS( name, invRoC, Aperture, Thickness, T, Lhr, Lar, incAngle )
            BSID = obj.addMirror( 'BS', 'Thickness', 0.0, 'T', 0.5, 'inc', incAngle, 'resolution', 0.5e-3 );
            obj.addDetector( 'reflMon' );


            obj.addOneProp( '', 'src-out', 'BS', portIndex, 0 );
            obj.addProp( '', 'BS-HRy', 'reflMon-in', 3000 );
 
            obj.optics.optList(BSID).HRfiles.addMap( '', '2e-9*cos(2*pi/lamX*y)'' .* cos(2*pi/lamX*x)''',0,0,0,'lamX', lamX);
        end
        
        % invq : 1/R - i lambda/pi 1/w^2 => -1/R - i lambda/pi 1/w^2
        function setupBaseMode( obj, varargin )
            qInv = -1i*1.064e-6/pi/0.02^2;
            root = obj.optics.findPortID( 'src', 1 );
            obj.cavities.fillQvals( root, qInv );
        end
    end
end