function CD = CDcalc(dat, w, xl, yl )
% function CD = CDcalc(dat, w, xl, yl )
%     if w > 0, average of dat in 2w is subtracted
if nargin == 3
    yl = xl;
end
dx = xl(2)-xl(1);
dy = yl(2)-yl(1);
[xg,yg] = meshgrid(xl,yl);
rsq = xg.^2 + yg.^2;
dat( isnan(dat) ) = 0;
if w > 0
    ind = find(rsq < (2*w)^2);
    ave = sum(sum(exp(-2*rsq(ind)/w^2).*dat(ind))) / sum(sum(exp(-2*rsq(ind)/w^2)));
else
    ave = 0;
end
CD = dx*dy*(4*pi/1.064e-6)^2*2/(pi*w^2)/4*sum(sum(exp(-2*rsq/w^2).*(dat-ave).^2));

end
