function [out, HG] = IMCscan( imc, RFs, aFSR )
%function [out, HG] = IMCscan( imc, RFs )

if ~exist( 'aFSR' )
    aFSR = 9.099454808141757e+06;
end

RFs = aFSR * RFs;

imc.lock;

NRFs = length(RFs);
out = zeros(NRFs,4);
numHGs = 5;
HG = zeros(NRFs,numHGs+1,numHGs+1);

for irf = 1:NRFs
    % set the cavity length to be the locked length + del
    imc.setRF( RFs(irf) );
    imc.calc( 1e-6, 0 );
    out(irf,1) = RFs(irf);
    out(irf,2) = imc.power('MC2-HRx-o');          % total power
    out(irf,3) = 1 - imc.HGFrac('MC2-HRx-o',0,0);
    out(irf,4) = imc.roundtripLoss;
    HG(irf,1:numHGs+1,1:numHGs+1) = abs(imc.HGCoef('MC2-HRx-o',0:numHGs,0:numHGs)).^2;

    if mod(irf, 10) == 1
        fprintf(1, '%d th event, power = %d\n', irf, out(irf,2) );
    end
end
