function [out, HG] = PRMIscan( prmi, del )

% lock FP
prmi.lock;

% FPprop ID
propID = prmi.props.findNamedProp( 'PROP12' );
% locked length
delL0 = prmi.props.propList(propID).delL;
Ndel = length(del);
out = zeros(Ndel,6);
HG = zeros(Ndel,5,5);

for il = 1:Ndel
    % set the cavity length to be the locked length + del
    prmi.props.setDelL( propID, delL0 + del(il) );
    prmi.calc(0,0); % default accuracy, no process report
    P = prmi.power('PRM-HR-i');          % total power
    out(il,1) = delL0 + del(il);
    out(il,2) = P;
    out(il,3) = 1 - abs(prmi.HGCoef('PRM-HR-i',0,0)).^2 / P;  % HOM
    out(il,4) = prmi.power('PRM-AR-o');
    out(il,5) = 1 - prmi.power('BS-HRx-o')/(prmi.power('BS-HRy-i') + prmi.power('BS-ARx-i'));
    out(il,6) = prmi.power('BS-ARy-o')/(prmi.power('BS-HRy-i') + prmi.power('BS-ARx-i'));

    for im = 0:4
        for in = 0:4
            HG(il,im+1,in+1) = abs(prmi.HGCoef('PRM-HR-i',im, in)).^2 / P;
        end
    end
    
    if mod(il, 10) == 1
        fprintf(1, '%d th event, power = %d\n', il, P );
    end
end
