function analPRMI( prmi, rng, fileName )

if exist('fileName', 'var')
    id = fopen( fileName, 'w' );
else
    id = 0;
end

ID4 = prmi.fields.findNamedField('BS-ARx-i');
ID6 = prmi.fields.findNamedField('BS-HRy-i');
ID8 = prmi.fields.findNamedField('PRM-HR-i');
ID9 = prmi.fields.findNamedField('PRM-AR-i');
ID10 = prmi.fields.findNamedField('PRM-AR-o');

ITMXID = prmi.optics.findNamedOptic( 'ITMX' );

if ~exist('rng', 'var')
    rng = [0, 8:11];
end

for iRoC = rng
    
    prmi.optics.optList(ITMXID).updateMirMaps('invRoC', iRoC*1e-6);
    prmi.lock;
    
    str = oneAnalPRM( prmi );
    
    str = sprintf( 'invRoC = %g %s', iRoC*1e-6, str )
    if id > 0
        fprintf( id, '%s\n', str );
    end
end

return
