% [names, IDs] = getZygoFiles( COC, dir )
%
% For COC = 'ITM' or 'ETM' or 'F', this searchs for xCOC_NN_R1_Figure.dat in folder specified in dir
% and returns NN as ID and the full name in name.
% IDs and names are arrays for all matching files.
%
function [names, IDs] = getZygoFiles( COC, location )
if ~exist( location, 'dir' )
    location = '';
end
files = dir( strcat( location, 'x', COC, '*R1*Figure.dat') );
leng = length( files );
if nargout == 2
    IDs = zeros( 1, leng );
end
names = cell(1, leng);
for index = 1:leng
    names{index} = files(index).name;
    if nargout == 2
        loc0 = strfind( names{index}, strcat( COC, '_' ) ) + length( COC ) + 1;
        loc1 = strfind( names{index}(loc0:end), '_' );
        loc1 = loc1(1) - 2 + loc0;
        IDs(index) = str2double( names{index}(loc0:loc1) );
    end
end
