function runELIGO( fileName )

fid = 1;
if exist('fileName', 'var')
    fid = fopen( fileName, 'w' );
end

eL = eLIGORC;

eL.lock(1e-6, 0);  % this suppresses long print out
% This is the field we analye
fieldName = 'RM-HR-o';
eL.LGFrac(fieldName, 0:5,0)

for iscale = 0:10
    scale = 0.1*iscale;
    
    % change the svcale value defined in setTRfiles
    % obj.setTRfiles( 'ITM', '', 'scale*eLIGORC.rmap(r)', 0.16, 0, 0, 'scale', 1 );
    eL.updateMirMaps('ITM', 'scale', scale);
    
    % find new locked state and stationary state
    eL.lock(1e-6, 0); 
    
    fprintf('\nscale = %g\n', scale );
        
    % find LG mode on RM
    LG = eL.LGFrac(fieldName, 0:5,0)
    % round trip loss
    RTL = eL.roundtripLoss(fieldName);
    % beam size
    [~,fitRM] = eL.gaussFit( 'RM-HR-o');
    [~,fitITM] = eL.gaussFit( 'ITM-AR-i');
    % cavity length
    [L0, delL] = eL.getPropLeng( 'PRC' );
    fprintf(fid, '%g\t%g\t%g\t%g\t%g\t%g\t%g\n', scale, eL.power(fieldName), LG(1), RTL, fitRM(1).w, fitITM(1).w, delL );
end

if fid ~= 1
    fclose( fid );
end
