% function dat = simpleTiltScan( fp, theta )
function [dat, delL0, delBase, pwr0] = scanLeng( fp, dlen, theta )

if ~exist('theta', 'var')
    theta = 0.1e-6;
end
fp.updateMirMaps( 'ETM', 'tiltE', 0 );
fp.lock;
[~, delBase] = fp.props.getPropLeng( 'FPprop' );
Ee0 = fp.getField('ETM-HR-o');
NEe0 = conj( Ee0 ) / sum(sum(abs(Ee0).^2));

fp.updateMirMaps( 'ETM', 'tiltE', theta );
fp.lock;

[~, delL0] = fp.props.getPropLeng( 'FPprop' );
pwr0 = fp.power('ETM-HR-o')

for idel = 1 : length( dlen )
    fp.props.setDelL( 'FPprop', delL0 + dlen(idel) );
    fp.calc;
    dat(idel,1) = dlen(idel);
    dat(idel,2) = fp.power('ETM-HR-o');
    Ee = fp.getField('ETM-HR-o');
    Ae = sum(sum( (Ee-Ee0) .* NEe0 ));
    dat(idel,3) = Ae;
    dat(idel,4) = 1 - abs(1+Ae).^2;
end

