function power = simpleTilt( fp, tilts )
% power = simpleTilt( fp, tilts )
%
% fp = FPIFO('tiltE', 1e-7 );
% fp.lock;
% Petm = fp.power('ETM-HR-o')
% tilts = 1e-7*(0:5);
% power = simpleTilt( fp, tilts );
% plot( tilts, power-power(1) );

power = zeros(size(tilts));

for itilt = 1:length(tilts)
    % change parametyer and update mirror maps
    fp.updateMirMaps('ETM', 'tiltE',tilts(itilt));
    % lock the cavity
    fp.lock(1e-5,0);
    % calculate power
    power(itilt) = fp.power('ETM-HR-o');
end
