% function dat = simpleTiltScan( fp, theta )
function dat = simpleTiltScan( fp, theta, lockIt )

if ~exist( 'lockIt', 'var' )
    lockIt = true;
end
fp.updateMirMaps( 'ETM', 'tiltE', 0 );
fp.lock;
Ee0 = fp.getField('ETM-HR-o');
NEe0 = conj( Ee0 ) / sum(sum(abs(Ee0).^2));
dat = zeros( length(theta), 8 );
for itilt = 1 : length( theta )
    fp.updateMirMaps( 'ETM', 'tiltE', theta(itilt) );
    if lockIt
        fp.lock;
    else
        fp.calc;
    end
    dat(itilt,1) = theta(itilt);
    dat(itilt,2) = fp.roundtripLoss;
    dat(itilt,3) = 1-fp.HGFrac('ETM-HR-o',0,0);
    dat(itilt,4) = fp.HGFrac('ETM-HR-o',0,1);
    dat(itilt,5) = fp.power('ETM-HR-o');
    Ee = fp.getField('ETM-HR-o');
    Ae = sum(sum( (Ee-Ee0) .* NEe0 ));
    dat(itilt,6) = Ae;
    [~,info] = fp.gaussFit('ITM-HR-i');
    dat(itilt,7) = info(2).c0;
    [~,info] = fp.gaussFit('ETM-HR-i');
    dat(itilt,8) = info(2).c0;
end
dat(:,9) = 1 - abs(1+dat(:,6)).^2;
